#drinc:libraries/dos.g

/*
 * ConvTime - convert a second relative to Jan 1 1978 into a printable date
 *	and time string.
 */

proc ConvTime(ulong time; register *char buffer)void:
    [7 * 3 + 1] char DOW = "SunMonTueWedThuFriSat";
    [12] uint MONTHSIZE = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
    [12 * 3 + 1] char MONTH = "JanFebMarAprMayJunJulAugSepOctNovDec";
    [12] uint monthSize;
    register *char p;
    register ulong hms, day;
    register uint i, j;

    hms := time % (24 * 60 * 60);
    day := time / (24 * 60 * 60);

    /* produce the day of the week and put it in the buffer: */

    p := &DOW[(day % 7) * 3];
    buffer* := p*;
    buffer := buffer + sizeof(char);
    p := p + sizeof(char);
    buffer* := p*;
    buffer := buffer + sizeof(char);
    p := p + sizeof(char);
    buffer* := p*;
    buffer := buffer + sizeof(char);
    buffer* := ' ';
    buffer := buffer + sizeof(char);

    /* produce the year number: */

    i := 1978;
    while
	j := if i % 4 = 0 then 366 else 365 fi;
	day >= j
    do
	day := day - j;
	i := i + 1;
    od;

    /* produce the month and day of month: */

    monthSize := MONTHSIZE;
    if j = 366 then
	monthSize[1] := 29;
    fi;
    j := 0;
    while day >= monthSize[j] do
	day := day - monthSize[j];
	j := j + 1;
    od;

    /* put month and day into the buffer: */

    p := &MONTH[j * 3];
    buffer* := p*;
    buffer := buffer + sizeof(char);
    p := p + sizeof(char);
    buffer* := p*;
    buffer := buffer + sizeof(char);
    p := p + sizeof(char);
    buffer* := p*;
    buffer := buffer + sizeof(char);
    buffer* := ' ';
    buffer := buffer + sizeof(char);

    day := day + 1;
    buffer* := if day < 10 then ' ' else day / 10 + '0' fi;
    buffer := buffer + sizeof(char);
    buffer* := day % 10 + '0';
    buffer := buffer + sizeof(char);

    buffer* := ' ';
    buffer := buffer + sizeof(char);

    /* put the time into the buffer: */

    j := hms / (60 * 60);
    buffer* := j / 10 + '0';
    buffer := buffer + sizeof(char);
    buffer* := j % 10 + '0';
    buffer := buffer + sizeof(char);

    buffer* := ':';
    buffer := buffer + sizeof(char);

    j := hms % (60 * 60) / 60;
    buffer* := j / 10 + '0';
    buffer := buffer + sizeof(char);
    buffer* := j % 10 + '0';
    buffer := buffer + sizeof(char);

    buffer* := ':';
    buffer := buffer + sizeof(char);

    j := hms % 60;
    buffer* := j / 10 + '0';
    buffer := buffer + sizeof(char);
    buffer* := j % 10 + '0';
    buffer := buffer + sizeof(char);

    buffer* := ' ';
    buffer := buffer + sizeof(char);

    /* now append the year and we are done: */

    buffer* := i / 1000 + '0';
    buffer := buffer + sizeof(char);
    buffer* := i / 100 % 10 + '0';
    buffer := buffer + sizeof(char);
    buffer* := i / 10 % 10 + '0';
    buffer := buffer + sizeof(char);
    buffer* := i % 10 + '0';
    buffer := buffer + sizeof(char);

    buffer* := '\e';
corp;

/*
 * GetCurrentTime - return a second number relative to Jan 1, 1978
 */

proc GetCurrentTime()ulong:
    DateStamp_t ds;

    DateStamp(&ds);
    ds.ds_Days * (24 * 60 * 60) + ds.ds_Minute * 60 + ds.ds_Tick / 50
corp;

/*
 * ConvTimeShort - convert a time value into string form: yyyy/mm/dd hh:mm:ss
 */

proc ConvTimeShort(ulong time; register *char buffer)void:
    [12] uint MONTHSIZE = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
    [12] uint monthSize;
    register ulong hms, day;
    register uint i, j;

    hms := time % (24 * 60 * 60);
    day := time / (24 * 60 * 60);

    /* produce the year number: */

    i := 1978;
    while
	j := if i % 4 = 0 then 366 else 365 fi;
	day >= j
    do
	day := day - j;
	i := i + 1;
    od;

    /* produce the month and day of month: */

    monthSize := MONTHSIZE;
    if j = 366 then
	monthSize[1] := 29;
    fi;
    j := 0;
    while day >= monthSize[j] do
	day := day - monthSize[j];
	j := j + 1;
    od;

    /* put year, month and day into the buffer: */

    buffer* := i / 1000 + '0';
    buffer := buffer + sizeof(char);
    buffer* := i / 100 % 10 + '0';
    buffer := buffer + sizeof(char);
    buffer* := i / 10 % 10 + '0';
    buffer := buffer + sizeof(char);
    buffer* := i % 10 + '0';
    buffer := buffer + sizeof(char);

    buffer* := '/';
    buffer := buffer + sizeof(char);

    j := j + 1;
    buffer* := j / 10 + '0';
    buffer := buffer + sizeof(char);
    buffer* := j % 10 + '0';
    buffer := buffer + sizeof(char);

    buffer* := '/';
    buffer := buffer + sizeof(char);

    day := day + 1;
    buffer* := day / 10 + '0';
    buffer := buffer + sizeof(char);
    buffer* := day % 10 + '0';
    buffer := buffer + sizeof(char);

    buffer* := ' ';
    buffer := buffer + sizeof(char);

    /* put the time into the buffer: */

    j := hms / (60 * 60);
    buffer* := j / 10 + '0';
    buffer := buffer + sizeof(char);
    buffer* := j % 10 + '0';
    buffer := buffer + sizeof(char);

    buffer* := ':';
    buffer := buffer + sizeof(char);

    j := hms % (60 * 60) / 60;
    buffer* := j / 10 + '0';
    buffer := buffer + sizeof(char);
    buffer* := j % 10 + '0';
    buffer := buffer + sizeof(char);

    buffer* := ':';
    buffer := buffer + sizeof(char);

    j := hms % 60;
    buffer* := j / 10 + '0';
    buffer := buffer + sizeof(char);
    buffer* := j % 10 + '0';
    buffer := buffer + sizeof(char);

    buffer* := '\e';
corp;
