#/include/rt.g

/*
 * LNGIO.DRC - read/write routines for long and ulong.
 */

extern
    _d_channelPutChar(char ch)void,
    _d_charsput(*char string)void,
    _d_channelGetChar()char,
    _d_channelUnGetChar(char ch)void,
    _d_channelError(CHANNELERROR ecode)void,
    _d_channelSkip()void;

/*
 * _d_lngiput - output a signed 32 bit value.
 */

proc _d_lngiput(register long n)void:
    register *char ptr;
    [12] char buffer;
    bool isNegative;

    if n < 0L then
	isNegative := true;
    else
	isNegative := false;
	n := -n;
    fi;
    ptr := &buffer[11];
    ptr* := '\e';
    while
	ptr := ptr - 1;
	ptr* := -make(n % 0L10, short) + '0';
	n := n / 0L10;
	n ~= 0L
    do
    od;
    if isNegative then
	ptr := ptr - 1;
	ptr* := '-';
    fi;
    _d_charsput(ptr);
corp;

/*
 * _d_lnguput - output an unsigned 32 bit value.
 */

proc _d_lnguput(register ulong n)void:
    register *char ptr;
    [11] char buffer;

    ptr := &buffer[10];
    ptr* := '\e';
    while
	ptr := ptr - 1;
	ptr* := make(n % 0L10, ushort) + '0';
	n := n / 0L10;
	n ~= 0L
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_lngxput - unformatted 32 bit unsigned base 16 output.
 */

proc _d_lngxput(register ulong n)void:
    register *char ptr;
    [9] char buffer;
    register byte digit;

    ptr := &buffer[8];
    ptr* := '\e';
    while
	digit := make(n, ushort) & 0x0f;
	ptr := ptr - 1;
	ptr* := digit + if digit <= 9 then
			    '0'
			else
			    'a' - 10
			fi;
	n := n >> 4;
	n ~= 0L
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_lngoput - unformatted 32 bit unsigned base 8 output.
 */

proc _d_lngoput(register ulong n)void:
    register *char ptr;
    [12] char buffer;

    ptr := &buffer[11];
    ptr* := '\e';
    while
	ptr := ptr - 1;
	ptr* := make(n, ushort) & 0x07 + '0';
	n := n >> 3;
	n ~= 0L
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_lngbput - unformatted 32 bit unsigned base 2 output.
 */

proc _d_lngbput(register ulong n)void:
    register *char ptr;
    [33] char buffer;

    ptr := &buffer[32];
    ptr* := '\e';
    while
	ptr := ptr - 1;
	ptr* := make(n, ushort) & 0x01 + '0';
	n := n >> 1;
	n ~= 0L
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_lngfiput - formatted 32 bit signed base 10 output.
 */

proc _d_lngfiput(register long n; register int cnt)void:
    register *char ptr;
    [11] char buffer;
    register char padChar;
    bool isNegative;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    if n < 0 then
	isNegative := true;
    else
	isNegative := false;
	n := -n;
    fi;
    ptr := &buffer[10];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	ptr := ptr - 1;
	ptr* := -make(n % 0L10, short) + '0';
	n := n / 0L10;
	n ~= 0L
    do
    od;
    if isNegative then
	cnt := cnt - 1;
	if padChar = '0' then
	    write(*; '-');
	else
	    ptr := ptr - 1;
	    ptr* := '-';
	fi;
    fi;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_lngfuput - formatted 32 bit unsigned base 10 output.
 */

proc _d_lngfuput(register ulong n; register int cnt)void:
    register *char ptr;
    [11] char buffer;
    register char padChar;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    ptr := &buffer[10];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	ptr := ptr - 1;
	ptr* := make(n % 0L10, ushort) + '0';
	n := n / 0L10;
	n ~= 0L
    do
    od;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_lngfxput - formatted 32 bit unsigned base 16 output.
 */

proc _d_lngfxput(register ulong n; register int cnt)void:
    register *char ptr;
    [9] char buffer;
    register byte digit;
    register char padChar;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    ptr := &buffer[8];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	digit := make(n, ushort) & 0x0f;
	ptr := ptr - 1;
	ptr* := digit + if digit <= 9 then
			    '0'
			else
			    'a' - 10
			fi;
	n := n >> 4;
	n ~= 0L
    do
    od;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_lngfoput - formatted 32 bit unsigned base 8 output.
 */

proc _d_lngfoput(register ulong n; register int cnt)void:
    register *char ptr;
    [12] char buffer;
    register char padChar;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    ptr := &buffer[11];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	ptr := ptr - 1;
	ptr* := make(n, ushort) & 0x07 + '0';
	n := n >> 3;
	n ~= 0L
    do
    od;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_lngfbput - formatted 32 bit unsigned base 2 output.
 */

proc _d_lngfbput(register ulong n; register int cnt)void:
    register *char ptr;
    [33] char buffer;
    register char padChar;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    ptr := &buffer[32];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	ptr := ptr - 1;
	ptr* := make(n, ushort) & 0x01 + '0';
	n := n >> 1;
	n ~= 0L
    do
    od;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_lngiget - get a signed 32 bit value.
 */

proc _d_lngiget()long:
    register proc()char r_d_channelGetChar;
    register long n, limit;
    register char ch;
    bool isNegative;
    register CHANNELERROR err;

    r_d_channelGetChar := _d_channelGetChar;
    _d_channelSkip();
    err := CH_OK;
    isNegative := false;
    ch := r_d_channelGetChar();
    if ch = '+' then
	ch := r_d_channelGetChar();
    elif ch = '-' then
	ch := r_d_channelGetChar();
	isNegative := true;
    elif ch = '\e' then
	err := CH_EOF;
    elif ch = '\n' then
	err := CH_MISSING;
    fi;
    if not (ch >= '0' and ch <= '9') and err = CH_OK then
	err := CH_BADCHAR;
    fi;
    n := 0L;
    limit := -0L214748364;
    while ch >= '0' and ch <= '9' do
	if n < limit or n = limit and (ch = '9' or not isNegative and ch = '8')
	then
	    err := CH_OVERFLOW;
	fi;
	n := n * 2;
	n := n * 4 + n - (ch - '0');
	ch := r_d_channelGetChar();
    od;
    if err ~= CH_OK then
	_d_channelError(err);
    fi;
    _d_channelUnGetChar(ch);
    if not isNegative then
	n := -n;
    fi;
    n
corp;

/*
 * _d_lnguget - get an unsigned 32 bit value.
 */

proc _d_lnguget()ulong:
    register ulong n, limit;
    register char ch;
    register CHANNELERROR err;

    err := CH_OK;
    _d_channelSkip();
    ch := _d_channelGetChar();
    if ch = '\e' then
	err := CH_EOF;
    elif ch = '\n' then
	err := CH_MISSING;
    elif not (ch >= '0' and ch <= '9') then
	err := CH_BADCHAR;
    fi;
    n := 0L;
    limit := 0L429496729;
    while ch >= '0' and ch <= '9' do
	if n > limit or n = limit and ch > '5' then
	    err := CH_OVERFLOW;
	fi;
	n := n << 1;
	n := n << 2 + n + (ch - '0');
	ch := _d_channelGetChar();
    od;
    if err ~= CH_OK then
	_d_channelError(err);
    fi;
    _d_channelUnGetChar(ch);
    n
corp;

/*
 * _d_lngxget - get an unsigned 32 bit base 16 value.
 */

proc _d_lngxget()ulong:
    register ulong n;
    register char ch;
    register CHANNELERROR err;

    err := CH_OK;
    _d_channelSkip();
    ch := _d_channelGetChar();
    if ch = '\e' then
	err := CH_EOF;
    elif ch = '\n' then
	err := CH_MISSING;
    elif not (ch >= '0' and ch <= '9' or
	    ch >= 'a' and ch <= 'f' or
	    ch >= 'A' and ch <= 'F') then
	err := CH_BADCHAR;
    fi;
    n := 0L;
    while ch >= '0' and ch <= '9' or
	ch >= 'a' and ch <= 'f' or
	ch >= 'A' and ch <= 'F'
    do
	if n > 0Lxfffffff then
	    err := CH_OVERFLOW;
	fi;
	n := n << 4 + (ch - if ch >= '0' and ch <= '9' then
				'0'
			    elif ch >= 'a' and ch <= 'f' then
				'a' - 10
			    else
				'A' - 10
			    fi);
	ch := _d_channelGetChar();
    od;
    if err ~= CH_OK then
	_d_channelError(err);
    fi;
    _d_channelUnGetChar(ch);
    n
corp;

/*
 * _d_lngoget - get an unsigned 32 bit base 8 value.
 */

proc _d_lngoget()ulong:
    register ulong n;
    register char ch;
    register CHANNELERROR err;

    err := CH_OK;
    _d_channelSkip();
    ch := _d_channelGetChar();
    if ch = '\e' then
	err := CH_EOF;
    elif ch = '\n' then
	err := CH_MISSING;
    elif not (ch >= '0' and ch <= '7') then
	err := CH_BADCHAR;
    fi;
    n := 0L;
    while ch >= '0' and ch <= '7' do
	if n > 0Lo3777777777 then
	    err := CH_OVERFLOW;
	fi;
	n := n << 3 + (ch - '0');
	ch := _d_channelGetChar();
    od;
    if err ~= CH_OK then
	_d_channelError(err);
    fi;
    _d_channelUnGetChar(ch);
    n
corp;

/*
 * _d_lngbget - get an unsigned 32 bit base 2 value.
 */

proc _d_lngbget()ulong:
    register ulong n;
    register char ch;
    register CHANNELERROR err;

    err := CH_OK;
    _d_channelSkip();
    ch := _d_channelGetChar();
    if ch = '\e' then
	err := CH_EOF;
    elif ch = '\n' then
	err := CH_MISSING;
    elif not (ch = '0' or ch = '1') then
	err := CH_BADCHAR;
    fi;
    n := 0L;
    while ch = '0' or ch = '1' do
	if n > 0Lb1111111111111111111111111111111 then
	    err := CH_OVERFLOW;
	fi;
	n := n << 1 + (ch - '0');
	ch := _d_channelGetChar();
    od;
    if err ~= CH_OK then
	_d_channelError(err);
    fi;
    _d_channelUnGetChar(ch);
    n
corp;
