/* Draco storage allocator - AmigaDOS version */

extern
    Write(ulong Fd; *char buffer; ulong length)void,
    Output()ulong,
    Exit(ulong status)void;

bool ErrorEnabled;

/*
 * _d_minitialize - called to start us up.
 */

proc _d_minitialize()void:

    ErrorEnabled := false;
corp;

/*
 * Malloc - allocate a block of storage.
 */

proc Malloc(ulong length)*byte:
    extern AllocMem(ulong length; ulong requirements)*byte;
    *byte p;

    p := AllocMem(length, 0L0);
    if p = nil and not ErrorEnabled then
	Write(Output(),"\n****Draco - storage allocation failure****\n",44);
	Exit(0L40);
    fi;
    p
corp;

/*
 * Mfree - free a block of storage.
 */

proc Mfree(*byte p; ulong length)void:
    extern FreeMem(*byte p; ulong length)void;

    FreeMem(p, length);
corp;

/*
 * MerrorSet - set our ErrorEnabled flag.
 */

proc MerrorSet(bool newFlag)void:

    ErrorEnabled := newFlag;
corp;

/*
 * MerrorGet - return the current setting of our ErrorEnabled flag.
 */

proc MerrorGet()bool:

    ErrorEnabled
corp;

/*
 * _d_malloc - interface routine called by compiler for 'new' construct.
 */

proc _d_malloc(ulong length)*byte:
    extern AllocMem(ulong length, requirements)*byte;
    *byte p;

    p := AllocMem(length, 0L0);
    if p = nil and not ErrorEnabled then
	Write(Output(),"\n****Draco - storage allocation failure****\n", 44);
	Exit(0L40);
    fi;
    p
corp;

/*
 * _d_mfree - interface routine called by compiler for 'free' construct.
 */

proc _d_mfree(*byte p; ulong length)void:
    extern FreeMem(*byte b; ulong length)void;

    FreeMem(p, length);
corp;
