#/include/rt.g

extern
    _d_channelPutChar(char ch)void,
    _d_channelGetChar()char,
    _d_channelUnGetChar(char ch)void,
    _d_channelError(CHANNELERROR errCode)void;

/*
 * _d_charput - send a character to the current text output channel.
 */

proc _d_charput(char ch)void:

    _d_channelPutChar(ch);
corp;

/*
 * _d_charaput - output a fixed sized array of characters.
 */

proc _d_charaput(register *char ptr; register ulong count)void:
    register proc(char ch)void r_d_channelPutChar;

    r_d_channelPutChar := _d_channelPutChar;
    while count ~= 0 do
	count := count - 1;
	r_d_channelPutChar(ptr*);
	ptr := ptr + sizeof(char);
    od;
corp;

/*
 * _d_channelput - write the name associated with a channel to a channel.
 */

proc _d_channelput(CHANNEL chan)void:
    extern
	_d_charsput(*char strng)void;

    case chan.ch_mode
    incase CH_STANDARD:
	_d_charsput("***terminal***");
    incase CH_FILE:
	_d_charsput(chan.ch_.ch_file*.f_name);
    incase CH_PROC:
	_d_charsput("***procedure***");
    incase CH_CHARS:
	_d_charsput("***string***");
    esac;
corp;

/*
 * _d_wordiput - unformatted 16 bit signed base 10 output.
 */

proc _d_wordiput(register int n)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [6] char buffer;

    if n < 0 then
	_d_channelPutChar('-');
    else
	n := -n;
    fi;
    ptr := &buffer[5];
    ptr* := '\e';
    while
	ptr := ptr - sizeof(char);
	ptr* := -(n % 10) + '0';
	n := n / 10;
	n ~= 0
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_worduput - unformatted 16 bit unsigned base 10 output.
 */

proc _d_worduput(register uint n)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [6] char buffer;

    ptr := &buffer[5];
    ptr* := '\e';
    while
	ptr := ptr - sizeof(char);
	ptr* := n % 10 + '0';
	n := n / 10;
	n ~= 0
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_wordxput - unformatted 16 bit unsigned base 16 output.
 */

proc _d_wordxput(register uint n)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [5] char buffer;
    register byte digit;

    ptr := &buffer[4];
    ptr* := '\e';
    while
	digit := n & 0x0f;
	ptr := ptr - sizeof(char);
	ptr* := digit + if digit <= 9 then
			    '0'
			else
			    'a' - 10
			fi;
	n := n >> 4;
	n ~= 0
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_wordoput - unformatted 16 bit unsigned base 8 output.
 */

proc _d_wordoput(register uint n)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [7] char buffer;

    ptr := &buffer[6];
    ptr* := '\e';
    while
	ptr := ptr - sizeof(char);
	ptr* := n & 0x07 + '0';
	n := n >> 3;
	n ~= 0
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_wordbput - unformatted 16 bit unsigned base 2 output.
 */

proc _d_wordbput(register uint n)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [17] char buffer;

    ptr := &buffer[16];
    ptr* := '\e';
    while
	ptr := ptr - sizeof(char);
	ptr* := n & 0x01 + '0';
	n := n >> 1;
	n ~= 0
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_byteiput - unformatted 8 bit signed base 10 output.
 */

proc _d_byteiput(register short n)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [4] char buffer;

    if n < 0 then
	_d_channelPutChar('-');
    else
	n := -n;
    fi;
    ptr := &buffer[3];
    ptr* := '\e';
    while
	ptr := ptr - sizeof(char);
	ptr* := -(n % 10) + '0';
	n := n / 10;
	n ~= 0
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_byteuput - unformatted 8 bit unsigned base 10 output.
 */

proc _d_byteuput(register byte n)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [4] char buffer;

    ptr := &buffer[3];
    ptr* := '\e';
    while
	ptr := ptr - sizeof(char);
	ptr* := n % 10 + '0';
	n := n / 10;
	n ~= 0
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_bytexput - unformatted 8 bit unsigned base 16 output.
 */

proc _d_bytexput(register byte n)void:
    register byte nibble;

    nibble := (n >> 4) & 0x0f;
    if nibble ~= 0 then
	_d_channelPutChar(nibble + if nibble <= 9 then '0' else 'a' - 10 fi);
    fi;
    nibble := n & 0x0f;
    _d_channelPutChar(nibble + if nibble <= 9 then '0' else 'a' - 10 fi);
corp;

/*
 * _d_byteoput - unformatted 8 bit unsigned base 8 output.
 */

proc _d_byteoput(register byte n)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [4] char buffer;

    ptr := &buffer[3];
    ptr* := '\e';
    while
	ptr := ptr - sizeof(char);
	ptr* := n & 0x07 + '0';
	n := n >> 3;
	n ~= 0
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_bytebput - unformatted 8 bit unsigned base 2 output.
 */

proc _d_bytebput(register byte n)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [9] char buffer;

    ptr := &buffer[8];
    ptr* := '\e';
    while
	ptr := ptr - sizeof(char);
	ptr* := n & 0x01 + '0';
	n := n >> 1;
	n ~= 0
    do
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_wordfiput - formatted 16 bit signed base 10 output.
 */

proc _d_wordfiput(register int n; register int cnt)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [7] char buffer;
    register char padChar;
    bool isNegative;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    if n < 0 then
	isNegative := true;
    else
	isNegative := false;
	n := -n;
    fi;
    ptr := &buffer[6];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	ptr := ptr - sizeof(char);
	ptr* := -(n % 10) + '0';
	n := n / 10;
	n ~= 0
    do
    od;
    if isNegative then
	cnt := cnt - 1;
	if padChar = '0' then
	    _d_channelPutChar('-');
	else
	    ptr := ptr - sizeof(char);
	    ptr* := '-';
	fi;
    fi;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_wordfuput - formatted 16 bit unsigned base 10 output.
 */

proc _d_wordfuput(register uint n; register int cnt)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [6] char buffer;
    register char padChar;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    ptr := &buffer[5];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	ptr := ptr - sizeof(char);
	ptr* := n % 10 + '0';
	n := n / 10;
	n ~= 0
    do
    od;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_wordfxput - formatted 16 bit unsigned base 16 output.
 */

proc _d_wordfxput(register uint n; register int cnt)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [5] char buffer;
    register byte digit;
    register char padChar;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    ptr := &buffer[4];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	digit := n & 0x0f;
	ptr := ptr - sizeof(char);
	ptr* := digit + if digit <= 9 then
			    '0'
			else
			    'a' - 10
			fi;
	n := n >> 4;
	n ~= 0
    do
    od;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_wordfoput - formatted 16 bit unsigned base 8 output.
 */

proc _d_wordfoput(register uint n; register int cnt)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [7] char buffer;
    register char padChar;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    ptr := &buffer[6];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	ptr := ptr - sizeof(char);
	ptr* := n & 0x07 + '0';
	n := n >> 3;
	n ~= 0
    do
    od;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_wordfbput - formatted 16 bit unsigned base 2 output.
 */

proc _d_wordfbput(register uint n; register int cnt)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [17] char buffer;
    register char padChar;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    ptr := &buffer[16];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	ptr := ptr - sizeof(char);
	ptr* := n & 0x01 + '0';
	n := n >> 1;
	n ~= 0
    do
    od;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_bytefiput - formatted 8 bit signed base 10 output.
 */

proc _d_bytefiput(register short n; register int cnt)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [5] char buffer;
    register char padChar;
    bool isNegative;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    if n < 0 then
	isNegative := true;
    else
	isNegative := false;
	n := -n;
    fi;
    ptr := &buffer[4];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	ptr := ptr - sizeof(char);
	ptr* := -(n % 10) + '0';
	n := n / 10;
	n ~= 0
    do
    od;
    if isNegative then
	cnt := cnt - 1;
	if padChar = '0' then
	    _d_channelPutChar('-');
	else
	    ptr := ptr - sizeof(char);
	    ptr* := '-';
	fi;
    fi;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_bytefuput - formatted 8 bit unsigned base 10 output.
 */

proc _d_bytefuput(register byte n; register int cnt)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [4] char buffer;
    register char padChar;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    ptr := &buffer[3];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	ptr := ptr - sizeof(char);
	ptr* := n % 10 + '0';
	n := n / 10;
	n ~= 0
    do
    od;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_bytefxput - formatted 8 bit unsigned base 16 output.
 */

proc _d_bytefxput(register byte n; register int cnt)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [3] char buffer;
    register byte digit;
    register char padChar;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    ptr := &buffer[2];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	digit := n & 0x0f;
	ptr := ptr - sizeof(char);
	ptr* := digit + if digit <= 9 then
			    '0'
			else
			    'a' - 10
			fi;
	n := n >> 4;
	n ~= 0
    do
    od;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_bytefoput - formatted 8 bit unsigned base 8 output.
 */

proc _d_bytefoput(register byte n; register int cnt)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [4] char buffer;
    register char padChar;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    ptr := &buffer[3];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	ptr := ptr - sizeof(char);
	ptr* := n & 0x07 + '0';
	n := n >> 3;
	n ~= 0
    do
    od;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_bytefbput - unformatted 8 bit unsigned base 2 output.
 */

proc _d_bytefbput(register byte n; register int cnt)void:
    extern
	_d_charsput(*char strng)void;
    register *char ptr;
    [9] char buffer;
    register char padChar;

    padChar :=
	if cnt < 0 then
	    cnt := - cnt;
	    '0'
	else
	    ' '
	fi;
    ptr := &buffer[8];
    ptr* := '\e';
    while
	cnt := cnt - 1;
	ptr := ptr - sizeof(char);
	ptr* := n & 0x01 + '0';
	n := n >> 1;
	n ~= 0
    do
    od;
    while cnt > 0 do
	cnt := cnt - 1;
	_d_channelPutChar(padChar);
    od;
    _d_charsput(ptr);
corp;

/*
 * _d_charsput - send a chars string to the current text output channel.
 */

proc _d_charsput(register *char ptr)void:
    register proc(char ch)void r_d_channelPutChar;

    r_d_channelPutChar := _d_channelPutChar;
    while ptr* ~= '\e' do
	r_d_channelPutChar(ptr*);
	ptr := ptr + sizeof(char);
    od;
corp;

/*
 * _d_writeln - write a newline to the current text output channel.
 */

proc _d_writeln()void:

    _d_channelPutChar('\n');
corp;

/*
 * _d_charget - get a character from the current text input channel.
 */

proc _d_charget()char:
    register char ch;

    ch := _d_channelGetChar();
    if ch = '\n' or ch = '\e' or ch = '\(0xff)' then
	_d_channelUnGetChar(ch);
	_d_channelError(if ch = '\e' then CH_EOF else CH_MISSING fi);
	'\e'
    else
	ch
    fi
corp;

/*
 * _d_charaget - get an array of characters from the current text channel.
 */

proc _d_charaget(register *char ptr; register ulong count)void:
    register proc()char r_d_channelGetChar;
    register char ch;
    register bool padding, gotSome;

    r_d_channelGetChar := _d_channelGetChar;
    padding := false;
    gotSome := false;
    while count ~= 0 do
	count := count - 1;
	ptr* := if padding then
		    ' '
		else
		    ch := r_d_channelGetChar();
		    if ch = '\n' or ch = '\e' or ch = '\(0xff)' then
			_d_channelUnGetChar(ch);
			if not gotSome then
			    _d_channelError(if ch = '\e' then
					      CH_EOF
					  else
					      CH_MISSING
					  fi);
			fi;
			padding := true;
			' '
		    else
			gotSome := true;
			ch
		    fi
		fi;
	ptr := ptr + sizeof(char);
    od;
corp;

/*
 * _d_charsget - get a string from the current input text channel.
 */

proc _d_charsget(register *char ptr)void:
    register proc()char r_d_channelGetChar;
    register char ch;
    register bool gotSome;

    r_d_channelGetChar := _d_channelGetChar;
    gotSome := false;
    while
	ch := r_d_channelGetChar();
	ch ~= '\n' and ch ~= '\e' and ch ~= '\(0xff)'
    do
	gotSome := true;
	ptr* := ch;
	ptr := ptr + sizeof(char);
    od;
    _d_channelUnGetChar(ch);
    if not gotSome and ch = '\e' then
	_d_channelError(CH_EOF);
    fi;
    ptr* := '\e';
corp;

/*
 * _d_byteiget - get a signed 8 bit base 10 value.
 */

proc _d_byteiget()short:
    extern _d_wordiget()int;
    register int n;

    n := _d_wordiget();
    if n < -128 or n > 127 then
	_d_channelError(CH_OVERFLOW);
    fi;
    n
corp;

/*
 * _d_byteuget - get an unsigned 8 bit base 10 value.
 */

proc _d_byteuget()ushort:
    extern _d_worduget()uint;
    uint n;

    n := _d_worduget();
    if n > 255 then
	_d_channelError(CH_OVERFLOW);
    fi;
    n
corp;

/*
 * _d_bytexget - get an unsigned 8 bit base 16 value.
 */

proc _d_bytexget()byte:
    extern _d_wordxget()uint;
    uint n;

    n := _d_wordxget();
    if n > 0xff then
	_d_channelError(CH_OVERFLOW);
    fi;
    n
corp;

/*
 * _d_byteoget - get an unsigned 8 bit base 8 value.
 */

proc _d_byteoget()byte:
    extern _d_wordoget()uint;
    uint n;

    n := _d_wordoget();
    if n > 0o377 then
	_d_channelError(CH_OVERFLOW);
    fi;
    n
corp;

/*
 * _d_bytebget - get an unsigned 8 bit base 2 value.
 */

proc _d_bytebget()byte:
    extern _d_wordbget()uint;
    uint n;

    n := _d_wordbget();
    if n > 0b11111111 then
	_d_channelError(CH_OVERFLOW);
    fi;
    n
corp;

/*
 * _d_wordiget - get a signed 16 bit base 10 value.
 */

proc _d_wordiget()int:
    extern _d_channelSkip()void;
    register proc()char r_d_channelGetChar;
    register int n;
    register char ch;
    bool isNegative;
    register CHANNELERROR err;

    r_d_channelGetChar := _d_channelGetChar;
    _d_channelSkip();
    err := CH_OK;
    isNegative := false;
    ch := r_d_channelGetChar();
    if ch = '+' then
	ch := r_d_channelGetChar();
    elif ch = '-' then
	ch := r_d_channelGetChar();
	isNegative := true;
    elif ch = '\e' then
	err := CH_EOF;
    elif ch = '\n' then
	err := CH_MISSING;
    fi;
    if not (ch >= '0' and ch <= '9') and err = CH_OK then
	err := CH_BADCHAR;
    fi;
    n := 0;
    while ch >= '0' and ch <= '9' do
	if n < -3276 or n = -3276 and (ch = '9' or not isNegative and ch = '8')
	then
	    err := CH_OVERFLOW;
	fi;
	n := n * 10 - (ch - '0');
	ch := r_d_channelGetChar();
    od;
    if err ~= CH_OK then
	_d_channelError(err);
    fi;
    _d_channelUnGetChar(ch);
    if isNegative then n else -n fi
corp;

/*
 * _d_worduget - get an unsigned 16 bit base 10 value.
 */

proc _d_worduget()uint:
    extern _d_channelSkip()void;
    register uint n;
    register char ch;
    register CHANNELERROR err;

    err := CH_OK;
    _d_channelSkip();
    ch := _d_channelGetChar();
    if ch = '\e' then
	err := CH_EOF;
    elif ch = '\n' then
	err := CH_MISSING;
    elif not (ch >= '0' and ch <= '9') then
	err := CH_BADCHAR;
    fi;
    n := 0;
    while ch >= '0' and ch <= '9' do
	if n > 6553 or n = 6553 and ch > '5' then
	    err := CH_OVERFLOW;
	fi;
	n := n * 10 + (ch - '0');
	ch := _d_channelGetChar();
    od;
    if err ~= CH_OK then
	_d_channelError(err);
    fi;
    _d_channelUnGetChar(ch);
    n
corp;

/*
 * _d_wordxget - get an unsigned 16 bit base 16 value.
 */

proc _d_wordxget()uint:
    extern _d_channelSkip()void;
    register uint n;
    register char ch;
    register CHANNELERROR err;

    err := CH_OK;
    _d_channelSkip();
    ch := _d_channelGetChar();
    if ch = '\e' then
	err := CH_EOF;
    elif ch = '\n' then
	err := CH_MISSING;
    elif not (ch >= '0' and ch <= '9' or
	ch >= 'a' and ch <= 'f' or
	ch >= 'A' and ch <= 'F')
    then
	err := CH_BADCHAR;
    fi;
    n := 0;
    while ch >= '0' and ch <= '9' or
	ch >= 'a' and ch <= 'f' or
	ch >= 'A' and ch <= 'F'
    do
	if n > 0xfff then
	    err := CH_OVERFLOW;
	fi;
	n := n << 4 + (ch - if ch >= '0' and ch <= '9' then
				'0'
			    elif ch >= 'a' and ch <= 'f' then
				'a' - 10
			    else
				'A' - 10
			    fi);
	ch := _d_channelGetChar();
    od;
    if err ~= CH_OK then
	_d_channelError(err);
    fi;
    _d_channelUnGetChar(ch);
    n
corp;

/*
 * _d_wordoget - get an unsigned 16 bit base 8 value.
 */

proc _d_wordoget()uint:
    extern _d_channelSkip()void;
    register uint n;
    register char ch;
    register CHANNELERROR err;

    err := CH_OK;
    _d_channelSkip();
    ch := _d_channelGetChar();
    if ch = '\e' then
	err := CH_EOF;
    elif ch = '\n' then
	err := CH_MISSING;
    elif not (ch >= '0' and ch <= '7') then
	err := CH_BADCHAR;
    fi;
    n := 0;
    while ch >= '0' and ch <= '7' do
	if n > 0o17777 then
	    err := CH_OVERFLOW;
	fi;
	n := n << 3 + (ch - '0');
	ch := _d_channelGetChar();
    od;
    if err ~= CH_OK then
	_d_channelError(err);
    fi;
    _d_channelUnGetChar(ch);
    n
corp;

/*
 * _d_wordbget - get an unsigned 16 bit base 2 value.
 */

proc _d_wordbget()uint:
    extern _d_channelSkip()void;
    register uint n;
    register char ch;
    register CHANNELERROR err;

    err := CH_OK;
    _d_channelSkip();
    ch := _d_channelGetChar();
    if ch = '\e' then
	err := CH_EOF;
    elif ch = '\n' then
	err := CH_MISSING;
    elif not (ch = '0' or ch <= '1') then
	err := CH_BADCHAR;
    fi;
    n := 0;
    while ch = '0' or ch = '1' do
	if n > 0b111111111111111 then
	    err := CH_OVERFLOW;
	fi;
	n := n << 1 + (ch - '0');
	ch := _d_channelGetChar();
    od;
    if err ~= CH_OK then
	_d_channelError(err);
    fi;
    _d_channelUnGetChar(ch);
    n
corp;

/*
 * _d_channelSkip - skip blanks and tabs when inputting a number.
 */

proc _d_channelSkip()void:
    register char ch;

    while
	ch := _d_channelGetChar();
	ch = ' ' or ch = '\t'
    do
    od;
    _d_channelUnGetChar(ch);
corp;

/*
 * _d_readln - read to the end of the current line.
 */

proc _d_readln()void:
    register char ch;

    while
	ch := _d_channelGetChar();
	ch ~= '\n' and ch ~= '\e' and ch ~= '\(0xff)'
    do
    od;
    if ch = '\e' then
	_d_channelUnGetChar('\e');
    fi;
corp;
