#/include/rt.g
#drinc:libraries/dos.g

/* rtio2.d - routines from rtio.d that do not reference the globals */

/*
 * exit - our standard routine for getting out.
 */

proc exit(int status)void:
    extern LineFlush()void;

    LineFlush();
    Exit(status + 20);
corp;

/*
 * FileCreate - create the named file.
 */

proc FileCreate(*char fileName)bool:
    FileHandle_t fd;

    fd := Open(fileName, MODE_NEWFILE);
    if fd = 0 then
	false
    else
	Close(fd);
	true
    fi
corp;

/*
 * FileDelete - delete the named file.
 */

proc FileDestroy(*char fileName)bool:

    DeleteFile(fileName)
corp;

/*
 * FileRename - rename a file.
 */

proc FileRename(*char oldName, newName)bool:

    Rename(oldName, newName)
corp;

/*
 * _d_get - input routine for binary mode reads.
 */

proc _d_get(register *byte buffer; register ulong length)ulong:
    extern
	_d_topChannel()*CHANNEL,
	_d_checkin(*CHANNEL chan)bool,
	_d_flushBuffer(*FILE f; bool isRandom)bool,
	_d_fillBuffer(*FILE f; bool isRandom)bool;
    register *CHANNEL chan;
    register *char pos;
    CHANNELUNIT unit;
    register ulong count, buffPos, inMax;
    bool hadEof;

    chan := _d_topChannel();
    count := 0L0;
    if chan*.ch_newError = CH_OK and _d_checkin(chan) then
	unit.ch_chars := chan*.ch_.ch_chars;
	count := length;
	if chan*.ch_mode = CH_PROC then
	    /* the simple case - just input the bytes */
	    while length ~= 0L0 do
		length := length - 0L1;
		buffer* := unit.ch_getByte();
		buffer := buffer + 1;
	    od;
	elif chan*.ch_mode = CH_FILE or chan*.ch_mode = CH_RANDOMFILE then
	    /* only other binary channel is a CH_FILE channel */
	    hadEof := false;
	    inMax := unit.ch_file*.f_inMax;
	    buffPos := unit.ch_file*.f_buffPos;
	    pos := &unit.ch_file*.f_buffer[buffPos];
	    while not hadEof and length ~= 0L0 do
		if buffPos = inMax then
		    /* need to read another bufferful of data from file */
		    if chan*.ch_mode = CH_RANDOMFILE then
			if not _d_flushBuffer(unit.ch_file, true) then
			    chan*.ch_error := CH_DISKFULL;
			    hadEof := true;
			else
			    unit.ch_file*.f_buffOffset :=
				unit.ch_file*.f_buffOffset + buffPos;
			    if not _d_fillBuffer(unit.ch_file, true) then
				chan*.ch_newError := CH_EOF;
				hadEof := true;
			    fi;
			fi;
		    elif not _d_fillBuffer(unit.ch_file, false) then
			chan*.ch_newError := CH_EOF;
			hadEof := true;
		    fi;
		    buffPos := 0L0;
		    pos := &unit.ch_file*.f_buffer[0];
		    inMax := unit.ch_file*.f_inMax;
		fi;
		if not hadEof then
		    length := length - 0L1;
		    buffer* := pos* - '\e';
		    buffer := buffer + 1;
		    pos := pos + 1;
		    buffPos := buffPos + 0L1;
		fi;
	    od;
	    count := count - length;
	    unit.ch_file*.f_buffPos := buffPos;
	else
	    Exit(0L35);
	fi;
    fi;
    count
corp;

/*
 * _d_put - output routine for binary mode writes.
 */

proc _d_put(register *byte buffer; register ulong length)ulong:
    extern
	_d_topChannel()*CHANNEL,
	_d_checkout(*CHANNEL chan)bool,
	_d_flushBuffer(*FILE f; bool isRandom)bool,
	_d_fillBuffer(*FILE f; bool isRandom)bool;
    register *CHANNEL chan;
    register *char pos;
    CHANNELUNIT unit;
    register ulong count, buffPos, buffLen;
    bool hadError;

    count := 0L;
    chan := _d_topChannel();
    if chan*.ch_newError = CH_OK and _d_checkout(chan) then
	unit.ch_chars := chan*.ch_.ch_chars;
	count := length;
	if chan*.ch_mode = CH_PROC then
	    /* the simple case - just output the bytes */
	    while length ~= 0L0 do
		length := length - 0L1;
		unit.ch_putByte(buffer*);
		buffer := buffer + 1;
	    od;
	elif chan*.ch_mode = CH_FILE or chan*.ch_mode = CH_RANDOMFILE then
	    /* only other binary channel is a CH_FILE channel */
	    hadError := false;
	    buffPos := unit.ch_file*.f_buffPos;
	    pos := &unit.ch_file*.f_buffer[buffPos];
	    buffLen := unit.ch_file*.f_buffLen;
	    while not hadError and length ~= 0L0 do
		if buffPos = buffLen then
		    /* need to write bufferful of data to file */
		    if buffPos > unit.ch_file*.f_outMax then
			unit.ch_file*.f_outMax := buffPos;
		    fi;
		    hadError :=
			if chan*.ch_mode = CH_FILE then
			    not _d_flushBuffer(unit.ch_file, false)
			else
			    if _d_flushBuffer(unit.ch_file, true) then
				ignore _d_fillBuffer(unit.ch_file, false);
				false
			    else
				true
			    fi
			fi;
		    /* handle writing sequentially to an empty RANDOMFILE;
		       prevent entering above on the next time around */
		    if unit.ch_file*.f_inMax = 0L0 then
			unit.ch_file*.f_inMax := 0L1;
		    fi;
		    buffPos := 0L0;
		    pos := &unit.ch_file*.f_buffer[0];
		fi;
		if not hadError then
		    length := length - 0L1;
		    pos* := buffer* + '\e';
		    pos := pos + 0L1;
		    buffer := buffer + 1;
		    buffPos := buffPos + 0L1;
		fi;
	    od;
	    count := count - length;
	    unit.ch_file*.f_buffPos := buffPos;
	    if buffPos > unit.ch_file*.f_outMax then
		unit.ch_file*.f_outMax := buffPos;
	    fi;
	    if buffPos > unit.ch_file*.f_inMax then
		unit.ch_file*.f_inMax := buffPos;
	    fi;
	    if hadError then
		chan*.ch_newError := CH_DISKFULL;
	    fi;
	else
	    Exit(0L35);
	fi;
    fi;
    count
corp;

/*
 * RawRead - user callable routine to read a large buffer of binary data.
 */

proc RawRead(CHANNEL chan; *byte buffer; ulong length)ulong:
    extern
	_d_setchannel(*CHANNEL chan)void,
	_d_unchannel()bool;
    ulong count;

    _d_setchannel(&chan);
    count := _d_get(buffer, length);
    ignore _d_unchannel();
    count
corp;

/*
 * LineRead - user callable routine to read a line from a text file. Up to
 *	the passed length of characters will be read, and if any remain on
 *	the line, they are skipped. The available length is returned.
 */

proc LineRead(CHANNEL chan; register *char buffer; register ulong length)ulong:
    extern
	_d_setchannel(*CHANNEL chan)void,
	_d_channelGetChar()char,
	_d_channelUnGetChar(char ch)void,
	_d_unchannel()bool;
    register proc()char r_d_channelGetChar;
    register ulong count;
    register char ch;

    r_d_channelGetChar := _d_channelGetChar;
    _d_setchannel(&chan);
    count := 0;
    while
	ch := r_d_channelGetChar();
	ch ~= '\n' and ch ~= '\e' and ch ~= '\(0xff)'
    do
	count := count + 1;
	if length ~= 0 then
	    length := length - 1;
	    buffer* := ch;
	    buffer := buffer + sizeof(char);
	fi;
    od;
    if ch ~= '\n' then
	_d_channelUnGetChar(ch);
    fi;
    ignore _d_unchannel();
    if ch = '\n' then
	count
    else
	LINE_EOF
    fi
corp;

/*
 * RawWrite - user callable routine to write a large buffer of binary data.
 */

proc RawWrite(CHANNEL chan; *byte buffer; ulong length)ulong:
    extern
	_d_setchannel(*CHANNEL chan)void,
	_d_unchannel()bool;
    ulong count;

    _d_setchannel(&chan);
    count := _d_put(buffer, length);
    ignore _d_unchannel();
    count
corp;

/*
 * LineWrite - user callable routine to write a line to a text output channel
 */

proc LineWrite(CHANNEL chan; register *char buffer;
	       register ulong length)ulong:
    extern
	_d_setchannel(*CHANNEL chan)void,
	_d_channelPutChar(char ch)void,
	_d_unchannel()bool;
    register proc(char ch)void r_d_channelPutChar;
    register ulong count;

    r_d_channelPutChar := _d_channelPutChar;
    _d_setchannel(&chan);
    count := 0;
    while
	if length = 0 then
	    false
	else
	    r_d_channelPutChar(buffer*);
	    chan.ch_newError = CH_OK
	fi
    do
	length := length - 1;
	count := count + 1;
	buffer := buffer + 1;
    od;
    if chan.ch_newError = CH_OK then
	r_d_channelPutChar('\n');
    fi;
    ignore _d_unchannel();
    count
corp;

/*
 * _d_IOerror - return the error code associated with a channel.
 */

proc _d_IOerror(register *CHANNEL chan)ushort:
    CHANNELERROR eCode;

    eCode := chan*.ch_error;
    chan*.ch_error := CH_OK;
    if chan*.ch_mode = CH_STANDARD then
	if chan*.ch_eof and chan*.ch_gotChar and chan*.ch_buffer = '\e' then
	    chan*.ch_gotChar := false;
	fi;
	chan*.ch_eof := false;
    fi;
    eCode - CH_OK
corp;

/*
 * SeekIn - user callable routine to seek randomly on a binary input file.
 */

proc SeekIn(CHANNEL chan; register ulong position)bool:
    extern
	_d_checkinrandom(*CHANNEL chan)bool,
	_d_flushBuffer(*FILE f; bool isRandom)bool,
	_d_fillBuffer(*FILE f; bool isRandom)bool;
    register *FILE f;
    register ulong savePosition;

    if not _d_checkinrandom(&chan) then
	false
    else
	f := chan.ch_.ch_file;
	savePosition := f*.f_buffOffset;
	if savePosition = POS_UNKNOWN or position < savePosition or
	    position >= savePosition + f*.f_inMax
	then
	    /* have to call _d_flushBuffer in case this SeekIn is on a file
	       which has been ReOpen'ed for both input and output */
	    if not _d_flushBuffer(f, true) then
		chan.ch_error := CH_DISKFULL;
		false
	    else
		/* required position is not in buffer */
		f*.f_buffOffset := position;
		if _d_fillBuffer(f, true) then
		    f*.f_buffPos := 0L0;
		    true
		else
		    f*.f_buffOffset := savePosition;
		    chan.ch_error := CH_BADSEEK;
		    false
		fi
	    fi
	else
	    f*.f_buffPos := position - savePosition;
	    true
	fi
    fi
corp;

/*
 * GetIn - user callable routine to return the current input position.
 */

proc GetIn(CHANNEL chan)ulong:
    extern _d_checkinrandom(*CHANNEL chan)bool;

    if not _d_checkinrandom(&chan) or
	    chan.ch_.ch_file*.f_buffOffset = POS_UNKNOWN then
	0L0
    else
	chan.ch_.ch_file*.f_buffOffset + chan.ch_.ch_file*.f_buffPos
    fi
corp;

/*
 * GetInMax - user callable routine to return the maximum file position.
 */

proc GetInMax(CHANNEL chan)ulong:
    extern _d_checkinrandom(*CHANNEL chan)bool;
    ulong oldPos;

    if not _d_checkinrandom(&chan) then
	0L0
    else
	oldPos := Seek(chan.ch_.ch_file*.f_fd, 0L0, OFFSET_END);
	Seek(chan.ch_.ch_file*.f_fd, oldPos, OFFSET_BEGINNING)
    fi
corp;

/*
 * ReOpen - user callable routine to enable reads/writes on the same file.
 */

proc ReOpen(CHANNEL chan, newChan)void:
    extern
	_d_checkinrandom(*CHANNEL chan)bool,
	_d_channelOpen(CHANNEL chan)void,
	_d_fillBuffer(*FILE f; bool isRandom)bool;
    *FILE f;

    if _d_checkinrandom(&chan) then
	f := chan.ch_.ch_file;
	if f*.f_buffOffset ~= POS_UNKNOWN then
	    chan.ch_error := CH_BADSEEK;
	else
	    chan.ch_mode := CH_RANDOMFILE;
	    newChan.ch_input := false;
	    newChan.ch_text := false;
	    newChan.ch_mode := CH_RANDOMFILE;
	    newChan.ch_.ch_file := f;
	    _d_channelOpen(newChan);
	    ignore _d_fillBuffer(f, false);
	fi;
    fi;
corp;

/*
 * _d_checkinrandom - local routine to check a random input file for OK.
 */

proc _d_checkinrandom(register *CHANNEL chan)bool:
    extern _d_checkin(*CHANNEL chan)bool;

    if not _d_checkin(chan) then
	false
    elif chan*.ch_mode ~= CH_FILE and chan*.ch_mode ~= CH_RANDOMFILE then
	chan*.ch_error := CH_BADSEEK;
	false
    else
	true
    fi
corp;

/*
 * _d_checkin - local routine to check an input channel for readiness.
 */

proc _d_checkin(register *CHANNEL chan)bool:
    extern _d_readErr()void;

    if chan*.ch_error ~= CH_OK then
	_d_readErr();
	false
    elif chan*.ch_closed then
	chan*.ch_error := CH_CLOSED;
	false
    elif chan*.ch_eof then
	chan*.ch_error := CH_EOF;
	false
    else
	true
    fi
corp;

/*
 * _d_readErr - local routine to abort on a bad read.
 */

proc _d_readErr()void:
    extern _d_printString(*char mess)void;

    _d_printString("\n****Draco: read on channel with error.****\n");
    Exit(0L35);
corp;

/*
 * RandomOut - user callable routine to enable random writes to a file.
 */

proc RandomOut(CHANNEL chan)void:
    extern
	_d_checkoutrandom(*CHANNEL chan)bool,
	_d_fillBuffer(*FILE f; bool isRandom)bool;
    *FILE f;

    if _d_checkoutrandom(&chan) then
	f := chan.ch_.ch_file;
	if f*.f_buffOffset ~= POS_UNKNOWN then
	    chan.ch_error := CH_BADSEEK;
	else
	    chan.ch_mode := CH_RANDOMFILE;
	    ignore _d_fillBuffer(f, false);
	fi;
    fi;
corp;

/*
 * SeekOut - user callable routine to seek randomly on an output file.
 */

proc SeekOut(CHANNEL chan; register ulong position)bool:
    extern
	_d_checkoutrandom(*CHANNEL chan)bool,
	_d_flushBuffer(*FILE f; bool isRandom)bool,
	_d_fillBuffer(*FILE f; bool isRandom)bool;
    register *FILE f;
    register ulong savePosition;

    if not _d_checkoutrandom(&chan) then
	false
    else
	f := chan.ch_.ch_file;
	savePosition := f*.f_buffOffset;
	if savePosition = POS_UNKNOWN or position < savePosition or
	    position >= savePosition + f*.f_inMax
	then
	    /* required position is not in buffer: flush, then read new */
	    if not _d_flushBuffer(f, true) then
		chan.ch_error := CH_DISKFULL;
		false
	    else
		f*.f_buffOffset := position;
		/* if the _d_fillBuffer fails, set 'inMax' to 0 so
		   it will be the same as 'buffPos' in _get */
		if not _d_fillBuffer(f, true) then
		    f*.f_inMax := 0L0;
		fi;
		f*.f_buffPos := 0L0;
		true
	    fi
	else
	    f*.f_buffPos := position - savePosition;
	    true
	fi
    fi
corp;

/*
 * GetOut - user callable routine to return the current output position.
 */

proc GetOut(CHANNEL chan)ulong:
    extern _d_checkoutrandom(*CHANNEL chan)bool;

    if not _d_checkoutrandom(&chan) or
	chan.ch_.ch_file*.f_buffOffset = POS_UNKNOWN
    then
	0L0
    else
	chan.ch_.ch_file*.f_buffOffset + chan.ch_.ch_file*.f_buffPos
    fi
corp;

/*
 * GetOutMax - user callable routine to return the maximum file position.
 */

proc GetOutMax(CHANNEL chan)ulong:
    extern _d_checkoutrandom(*CHANNEL chan)bool;
    ulong oldPos;

    if not _d_checkoutrandom(&chan) then
	0L0
    else
	oldPos := Seek(chan.ch_.ch_file*.f_fd, 0L0, OFFSET_END);
	Seek(chan.ch_.ch_file*.f_fd, oldPos, OFFSET_BEGINNING)
    fi
corp;

/*
 * FlushOut - user callable routine to flush a channel's output buffer.
 */

proc FlushOut(CHANNEL chan)void:
    extern
	_d_checkoutrandom(*CHANNEL chan)bool,
	_d_flushBuffer(*FILE f; bool isRandom)bool;
    ulong buffPos;

    if _d_checkoutrandom(&chan) then
	buffPos := chan.ch_.ch_file*.f_buffPos;
	if not _d_flushBuffer(chan.ch_.ch_file, true) then
	    chan.ch_error := CH_BADSEEK;
	fi;
	chan.ch_.ch_file*.f_buffPos := buffPos;
    fi;
corp;

/*
 * TextAppend - user callable routine to seek to the end of a text output.
 */

proc TextAppend(CHANNEL chan)bool:
    extern _d_checkoutrandom(*CHANNEL chan)bool;

    _d_checkoutrandom(&chan) and
	 Seek(chan.ch_.ch_file*.f_fd, 0L0, OFFSET_END) ~= -0L1
corp;

/*
 * _d_checkoutrandom - check a file for random output.
 */

proc _d_checkoutrandom(register *CHANNEL chan)bool:
    extern _d_checkout(*CHANNEL chan)bool;

    if not _d_checkout(chan) then
	false
    elif chan*.ch_mode ~= CH_FILE and chan*.ch_mode ~= CH_RANDOMFILE then
	chan*.ch_error := CH_BADSEEK;
	false
    else
	true
    fi
corp;

/*
 * _d_checkout - check an output file for binary output.
 */

proc _d_checkout(register *CHANNEL chan)bool:
    extern _d_writeErr()void;

    if chan*.ch_error ~= CH_OK then
	_d_writeErr();
	false
    elif chan*.ch_closed then
	chan*.ch_error := CH_CLOSED;
	false
    else
	true
    fi
corp;

/*
 * _d_writeErr - local routine to abort on a bad write.
 */

proc _d_writeErr()void:
    extern _d_printString(*char mess)void;

    _d_printString("\n****Draco: write on channel with error.****\n");
    Exit(0L35);
corp;

/*
 * _d_fopen1 - open a file for text input.
 */

proc _d_fopen1(register *CHANNEL chan; FILE f; *char name; ulong buffLen)bool:
    extern _d_fopen(*CHANNEL chan; FILE f; *char name; ulong buffLen)bool;

    chan*.ch_input := true;
    chan*.ch_text := true;
    _d_fopen(chan, f, name, buffLen)
corp;

/*
 * _d_fopen2 - open a file for binary input.
 */

proc _d_fopen2(register *CHANNEL chan; FILE f; *char name; ulong buffLen)bool:
    extern _d_fopen(*CHANNEL chan; FILE f; *char name; ulong buffLen)bool;

    chan*.ch_input := true;
    chan*.ch_text := false;
    _d_fopen(chan, f, name, buffLen)
corp;

/*
 * _d_fopen3 - open a file for text output.
 */

proc _d_fopen3(register *CHANNEL chan; FILE f; *char name; ulong buffLen)bool:
    extern _d_fopen(*CHANNEL chan; FILE f; *char name; ulong buffLen)bool;

    chan*.ch_input := false;
    chan*.ch_text := true;
    _d_fopen(chan, f, name, buffLen)
corp;

/*
 * _d_fopen4 - open a file for binary output.
 */

proc _d_fopen4(register *CHANNEL chan; FILE f; *char name; ulong buffLen)bool:
    extern _d_fopen(*CHANNEL chan; FILE f; *char name; ulong buffLen)bool;

    chan*.ch_input := false;
    chan*.ch_text := false;
    _d_fopen(chan, f, name, buffLen)
corp;

/*
 * _d_popen1 - open a text input channel using a source proc.
 */

proc _d_popen1(register *CHANNEL chan; proc()char getChar)bool:
    extern _d_channelOpen(*CHANNEL chan)void;

    _d_channelOpen(chan);
    chan*.ch_mode := CH_PROC;
    chan*.ch_input := true;
    chan*.ch_text := true;
    chan*.ch_.ch_getChar := getChar;
    true
corp;

/*
 * _d_popen2 - open a binary input channel using a source proc.
 */

proc _d_popen2(register *CHANNEL chan; proc()byte getByte)bool:
    extern _d_channelOpen(*CHANNEL chan)void;

    _d_channelOpen(chan);
    chan*.ch_mode := CH_PROC;
    chan*.ch_input := true;
    chan*.ch_text := false;
    chan*.ch_.ch_getByte := getByte;
    true
corp;

/*
 * _d_popen3 - open a text output channel using a sink proc.
 */

proc _d_popen3(register *CHANNEL chan; proc(char ch)void putChar)bool:
    extern _d_channelOpen(*CHANNEL chan)void;

    _d_channelOpen(chan);
    chan*.ch_mode := CH_PROC;
    chan*.ch_input := false;
    chan*.ch_text := true;
    chan*.ch_.ch_putChar := putChar;
    true
corp;

/*
 * _d_popen4 - open a binary output channel using a sink proc.
 */

proc _d_popen4(register *CHANNEL chan; proc(byte b)void putByte)bool:
    extern _d_channelOpen(*CHANNEL chan)void;

    _d_channelOpen(chan);
    chan*.ch_mode := CH_PROC;
    chan*.ch_input := false;
    chan*.ch_text := false;
    chan*.ch_.ch_putByte := putByte;
    true
corp;

/*
 * _d_copen1 - open a text input channel using a chars pointer.
 */

proc _d_copen1(register *CHANNEL chan; *char ptr)bool:
    extern _d_channelOpen(*CHANNEL chan)void;

    _d_channelOpen(chan);
    chan*.ch_mode := CH_CHARS;
    chan*.ch_input := true;
    chan*.ch_text := true;
    chan*.ch_.ch_chars := ptr;
    chan*.ch_closed := ptr = nil;
    true
corp;

/*
 * _d_copen3 - open a text output channel using a chars pointer.
 */

proc _d_copen3(register *CHANNEL chan; *char ptr)bool:
    extern _d_channelOpen(*CHANNEL chan)void;

    _d_channelOpen(chan);
    chan*.ch_mode := CH_CHARS;
    chan*.ch_input := false;
    chan*.ch_text := true;
    chan*.ch_.ch_chars := ptr;
    chan*.ch_closed := ptr = nil;
    true
corp;

/*
 * _d_sopen1 - open a text input channel for standard input.
 */

proc _d_sopen1(register *CHANNEL chan)bool:
    extern _d_channelOpen(*CHANNEL chan)void;

    _d_channelOpen(chan);
    chan*.ch_mode := CH_STANDARD;
    chan*.ch_input := true;
    chan*.ch_text := true;
    true
corp;

/*
 * _d_sopen3 - open a text output channel for standard output.
 */

proc _d_sopen3(register *CHANNEL chan)bool:
    extern _d_channelOpen(*CHANNEL chan)void;

    _d_channelOpen(chan);
    chan*.ch_mode := CH_STANDARD;
    chan*.ch_input := false;
    chan*.ch_text := true;
    true
corp;

/*
 * _d_close - close a channel.
 */

proc _d_close(register *CHANNEL chan)bool:
    extern
	LineFlush()void,
	_d_flushBuffer(*FILE f; bool isRandom)bool;
    bool success;

    success := true;
    if chan*.ch_closed then
	chan*.ch_error := CH_CLOSED;
	success := false;
    else
	if chan*.ch_mode = CH_STANDARD and not chan*.ch_input then
	    LineFlush();
/* Empire at least doesn't want this.
	elif chan*.ch_mode = CH_PROC and chan*.ch_text and not chan*.ch_input
	then
	    chan*.ch_.ch_putChar('\e');
*/
	elif chan*.ch_mode = CH_CHARS and not chan*.ch_input then
	    chan*.ch_.ch_chars* := '\e';
	elif chan*.ch_mode = CH_FILE or chan*.ch_mode = CH_RANDOMFILE then
	    if not chan*.ch_input then
		if chan*.ch_text then
		    chan*.ch_.ch_file*.f_outMax :=
			chan*.ch_.ch_file*.f_buffPos;
		fi;
		if not _d_flushBuffer(chan*.ch_.ch_file,
				     chan*.ch_mode = CH_RANDOMFILE)
		then
		    success := false;
		fi;
	    fi;
	    if chan*.ch_.ch_file*.f_fd ~= 0L0 then
		/* if ReOpen'd, don't want to close it twice */
		Close(chan*.ch_.ch_file*.f_fd);
		chan*.ch_.ch_file*.f_fd := 0L0;
	    fi;
	fi;
    fi;
    chan*.ch_closed := true;
    success
corp;

/*
 * _d_fillBuffer - fill a file's buffer. Return false on true EOF.
 */

proc _d_fillBuffer(register *FILE f; bool isRandom)bool:
    register ulong buffOffset;
    bool hadEof;

    hadEof := false;
    buffOffset := f*.f_buffOffset;
    if isRandom then
	if Seek(f*.f_fd, buffOffset, OFFSET_BEGINNING) = -0L1 then
	    f*.f_inMax := 0L0;
	    hadEof := true;
	fi;
    else
	f*.f_buffOffset :=
	    if buffOffset = POS_UNKNOWN then
		0L0
	    else
		buffOffset + f*.f_buffLen
	    fi;
    fi;
    if not hadEof then
	f*.f_inMax := Read(f*.f_fd, &f*.f_buffer[0], f*.f_buffLen);
	if f*.f_inMax = 0L0 or f*.f_inMax = -0L1 then
	    hadEof := true;
	fi;
    fi;
    f*.f_buffPos := 0L0;
    not hadEof
corp;

/*
 * _d_flushBuffer - flush a file's buffer. Return false if failed.
 */

proc _d_flushBuffer(register *FILE f; bool isRandom)bool:
    register ulong wLen, len, offset;
    bool hadError;

    len := f*.f_outMax;
    if len = 0L0 then
	true
    else
	hadError := false;
	if isRandom then
	    if Seek(f*.f_fd, f*.f_buffOffset, OFFSET_BEGINNING) = -0L1 then
		hadError := true;
	    fi;
	fi;
	if not hadError then
	    offset := 0;
	    while
		wLen := Write(f*.f_fd, &f*.f_buffer[offset], len);
		len := len - wLen;
		len ~= 0 and wLen ~= -1
	    do
		offset := offset + wLen;
	    od;
	    if wLen = -1 then
		hadError := true;
	    fi;
	fi;
	f*.f_buffPos := 0L0;
	f*.f_outMax := 0L0;
	not hadError
    fi
corp;

/*
 * _d_channelOpen - standard operations for opening a channel.
 */

proc _d_channelOpen(register *CHANNEL chan)void:

    chan*.ch_eof := false;
    chan*.ch_closed := false;
    chan*.ch_error := CH_OK;
    chan*.ch_newError := CH_OK;
    chan*.ch_gotChar := false;
corp;
