#/include/util.g

/*
 * CharsLen - return the length of the passed chars value.
 */

proc CharsLen(register *char p)ulong:
    register ulong l;

    l := 0;
    while p* ~= '\e' do
	p := p + 1;
	l := l + 1;
    od;
    l
corp;

/*
 * CharsEqual - return true if the two passed chars values are equal.
 */

proc CharsEqual(register *char p, q)bool:

    while p* = q* and p* ~= '\e' do
	p := p + 1;
	q := q + 1;
    od;
    p* = q*
corp;

/*
 * CharsCopy - copy the second chars parameter into the first.
 */

proc CharsCopy(register *char p, q)void:

    while
	p* := q*;
	q* ~= '\e'
    do
	q := q + 1;
	p := p + 1;
    od;
corp;

/*
 * CharsTail - copy 2nd to first, return tail of first.
 */

proc CharsTail(register *char p, q)*char:

    while q* ~= '\e' do
	p* := q*;
	p := p + sizeof(char);
	q := q + sizeof(char);
    od;
    p
corp;

/*
 * CharsCmp - compare the two chars values for =, < or >.
 */

proc CharsCmp(register *char p, q)COMPARISON:

    while p* = q* and p* ~= '\e' do
	p := p + 1;
	q := q + 1;
    od;
    if p* = q* then
	EQUAL
    elif p* < q* then
	LESS
    else
	GREATER
    fi
corp;

/*
 * CharsConcat - concatenate the 2nd chars value to the end of the first.
 */

proc CharsConcat(register *char p, q)void:

    while p* ~= '\e' do
	p := p + 1;
    od;
    while
	p* := q*;
	q* ~= '\e'
    do
	q := q + 1;
	p := p + 1;
    od;
corp;

/*
 * CharsCopyN - copy at most N characters from 2nd chars value to first.
 */

proc CharsCopyN(register *char p, q; register ulong n)void:

    while n ~= 0 and q* ~= '\e' do
	p* := q*;
	p := p + 1;
	q := q + 1;
	n := n - 1;
    od;
    p* := '\e';
corp;

/*
 * CharsIndex - return the index of the first occurrence of the 2nd chars
 *		parameter in the first chars parameter (-1 if none).
 */

proc CharsIndex(*char start, ptr)long:
    register *char target, p, q;

    target := start;
    while
	p := target;
	q := ptr;
	while p* = q* and q* ~= '\e' do
	    q := q + 1;
	    p := p + 1;
	od;
	q* ~= '\e' and p* ~= '\e'
    do
	target := target + 1;
    od;
    if q* ~= '\e' then
	-1
    else
	target - start
    fi
corp;
