#drinc:util.g

bool
    DOWRITES = false,
    READSEQUENTIAL = false,
    READRANDOM = true ;

channel output binary Chout;
channel input binary Chin;

proc checkError()void:
    ushort ec;

    ec := ioerror(Chin);
    if ec ~= CH_OK then
	case ec
	incase CH_EOF:
	    writeln("end of file on read");
	incase CH_BADSEEK:
	    writeln("bad seek on read");
	incase CH_DISKFULL:
	    writeln("disk full on read");
	incase CH_BADREAD:
	    writeln("read error on read");
	default:
	    writeln("other read error: ", ec);
	esac;
	close(Chin);
	exit(1);
    fi;
corp;

proc main()void:
    int SIZE = 10240, COUNT = 3;
    [SIZE] byte buffer;
    uint i, len, pos, n;
    file(1024) f;
    ulong fd;

    if DOWRITES then
	for i from 0 upto SIZE - 1 do
	    buffer[i] := i;
	od;
	FileDestroy("test.dat");
	if not FileCreate("test.dat") then
	    writeln("bad create");
	    exit(1);
	fi;
	if not open(Chout, f, "test.dat") then
	    writeln("bad write open");
	    exit(1);
	fi;
	for n from 1 upto COUNT do
	    len := RawWrite(Chout, &buffer[0], SIZE);
	    writeln("wrote ", len, " bytes.");
	od;
	if not close(Chout) then
	    writeln("bad write close");
	    exit(1);
	fi;
    fi;
    if not open(Chin, f, "test.dat") then
	writeln("bad read open");
	exit(1);
    fi;
    if READSEQUENTIAL then
	for n from 1 upto COUNT + 1 do
	    for i from 0 upto SIZE - 1 do
		buffer[i] := 0;
	    od;
	    len := RawRead(Chin, &buffer[0], SIZE);
	    checkError();
	    writeln("read ", len, " bytes.");
	    for i from 0 upto SIZE - 1 do
		if buffer[i] ~= i % 256 then
		    writeln("Byte ", i, " is ", buffer[i]:x:-2,
			    " instead of ", i % 256:x:-2, ".");
		fi;
	    od;
	od;
    fi;
    if READRANDOM then
	while
	    write("seek to: ");
	    readln(pos)
	do
	    write("count: ");
	    readln(n);
	    if n > SIZE then
		n := SIZE;
	    elif n = 0 then
		n := 1;
	    fi;
	    if not SeekIn(Chin, pos) then
		writeln("bad read seek");
		checkError();
	    fi;
	    for i from 0 upto n - 1 do
		buffer[i] := 0;
	    od;
	    len := RawRead(Chin, &buffer[0], n);
	    checkError();
	    writeln("read ", len, " bytes.");
	    for i from 0 upto n - 1 do
		if buffer[i] ~= ((i + pos) % SIZE) % 256 then
		    writeln("Byte ", i, " is ", buffer[i]:x:-2,
			    " instead of ", ((i + pos) % SIZE) % 256:x:-2);
		fi;
	    od;
	od;
    fi;
    if not close(Chin) then
	writeln("bad read close.");
	exit(1);
    fi;
corp;
